#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_AccCheckCFG.h"
std::auto_ptr<M_AccCheckCFG> M_AccCheckCFG::msSingleton(nullptr);

int M_AccCheckCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_AccCheckCFGData* M_AccCheckCFG::GetData(std::string ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<std::string, M_AccCheckCFGData>& M_AccCheckCFG::GetMapData()
{
	return mMapData;
}

void M_AccCheckCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_AccCheckCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_AccCheckCFGData data;
		data.mID = element->Attribute("ID");
		data.mAccTableName = element->Attribute("AccTableName");
		data.mAccKey = element->Attribute("AccKey");
		data.mPayTableName = element->Attribute("PayTableName");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_AccCheckCFG Loaded. Load Data:%u", mMapData.size());
}

void M_AccCheckCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_AccCheckCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_AccCheckCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_AccCheckCFGData data;
		LuaCfgHelper::readString(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "AccTableName", data.mAccTableName);
		LuaCfgHelper::readString(L, "AccKey", data.mAccKey);
		LuaCfgHelper::readString(L, "PayTableName", data.mPayTableName);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_AccCheckCFG Loaded. Load Data:%u", mMapData.size());
}

void M_AccCheckCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_AccCheckCFG* M_AccCheckCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_AccCheckCFG());
	}
	return msSingleton.get();
}

void M_AccCheckCFG::Release()
{
	msSingleton.reset(nullptr);
}
